#pragma once

#include "../core/storage/storage.h"
#include "../core/resources/resources.h"

#include <stdlib.h>

extern int g_num_loads;

class intval
{
public:
	intval(int val = 0)
	{
		this->m_value = val;
	}

	intval(const storage::buffer& data) : intval(0)
	{
		// slow to construct
		std::this_thread::sleep_for(std::chrono::duration<double, std::ratio<1>>(0.1));

		// construct
		this->m_value = (int)atol(data.ptr<char>(0));

		g_num_loads++;
	}

	void set(const int val)
	{
		this->m_value = val;
	}

	const int& get(void) const
	{
		return this->m_value;
	}

private:
	int m_value;
};

using intval_async_resource_t = resources::async_proxy<intval>;