#include <stdio.h>

#include "../core/utils/utils.h"
#include "../core/debug/evemon.h"
#include "../core/debug/exception.h"
#include "../core/threads/event.h"
#include "../core/net/net.h"
#include "../core/instancers/instancer.h"
#include "../core/storage/storage.h"
#include "../core/test/test.h"
#include "../core/resources/resources.h"

#include "intval.h"

/* Null Resource Test */
class null_resource_test : public test::base
{
public:
	virtual void run(void) const override
	{
		_comment("Null Resource Test");

		const char* resname = "file://invalid";

		// set null resource
		resources::set_null_resource(std::make_shared<const intval>(-1));

		// create resource
		resources::async_proxy<intval> r(resname);

		// expect -1
		EXPECT_TRUE("Invalid asynchronous resource shall not timeout", r.wait(1.0));
		EXPECT_NOTNULL("Invalid asynchronous resource shall not be null", r.get());
		EXPECT_INT("Invalid asynchronous resource shall give -1", r->get(), -1);

		// clear null resource
		resources::set_null_resource<intval>(nullptr);
	}
};

REGISTER_TEST(null_resource_test);