#pragma once

#include "../core/storage/base.h"
#include "../core/resources/resources.h"

#include "intval.h"

class embedded_sample : public storage::base
{
public:
	IMPLEMENT_STORAGE;

public:
	embedded_sample(void) {}

	embedded_sample(const std::string& resource)
	{
		this->m_res = resources::async_proxy<intval>(resource);
		
		// wait for synchronization
		this->m_res.wait();
	}

	int eval(void) const
	{
		this->m_res.wait();

		return this->m_res->get();
	}

private:
	intval_async_resource_t m_res;
};

class derived_sample : public intval_async_resource_t
{
public:
	IMPLEMENT_STORAGE;

public:
	derived_sample(void)
	{
		this->m_other = 0;
	}

	derived_sample(const std::string& resource, int other) : intval_async_resource_t(resource) 
	{
		this->m_other = other;

		// wait for synchronization
		this->wait();
	}

	int eval(void) const
	{
		this->wait();

		return this->ptr()->get();
	}

	int other(void) const
	{
		return this->m_other;
	}

private:
	int m_other;
};
